; ============  

Function control(ent) ;   WASD
        If KeyDown(17) MoveEntity ent,0,0,.1*dt
        If KeyDown(31) MoveEntity ent,0,0,-.1*dt
        If KeyDown(30) MoveEntity ent,-.1*dt,0,0
        If KeyDown(32) MoveEntity ent,.1*dt,0,0
End Function

Function arrowkeys(ent) ; ??????? ?????????? WASD
        If KeyDown(200) MoveEntity ent,0,0,.1*dt
        If KeyDown(208) MoveEntity ent,0,0,-.1*dt
        If KeyDown(203) TurnEntity ent,0,.2*dt,0
        If KeyDown(205) TurnEntity ent,0,-.2*dt,0
End Function

Function mouselook(ent) ;   

	mxspd#=MouseXSpeed()*0.25
	myspd#=MouseYSpeed()*0.25

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2	
	
	campitch#=EntityPitch(ent)+myspd#
	
	If campitch#<-85 Then campitch#=-85 ;  ,         ,    
	If campitch#>85 Then campitch#=85

	RotateEntity ent,campitch#,EntityYaw(ent)-mxspd#,EntityRoll(ent)
End Function

Function LoadSkyBox( file$ )
	m=CreateMesh()
	;front face
	b=LoadBrush( file$+"_FR.dds",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3:
	FreeBrush b
	;right face
	b=LoadBrush( file$+"_LF.dds",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( file$+"_BK.dds",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( file$+"_RT.dds",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( file$+"_UP.dds",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;bottom face	
	b=LoadBrush( file$+"_DN.dds",49 )
	If b=0 b=CreateBrush (0,30,50)
	s=CreateSurface( m,b )
	AddVertex s,-1,-1,-1,1,0:AddVertex s,+1,-1,-1,1,1
	AddVertex s,+1,-1,+1,0,1:AddVertex s,-1,-1,+1,0,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	ScaleMesh m,100,100,100
	FlipMesh m
	EntityFX m,1+8
	Return m
End Function

Global dt

Graphics 800,600,32,3
SetBuffer BackBuffer()

font1 = LoadFont("Comic Sans MS",48,1,1)

font2 = LoadFont("Comic Sans MS",72,1,1)



Repeat
Cls
Color 255,128,0
If MouseX() < 400 Then
	If MouseY() < 300 Then
		Color 255,128,0
		Rect 0,0,400,300,0
		SetFont font2
		Text 200,150,"640x480",1,1
		Color 200,0,0
		SetFont font1
		Text 200,450,"1024x768",1,1
		Text 600,150,"800x600",1,1
		Text 600,450,"1280x1024",1,1
		GW = 640
		GH = 480
		If MouseHit(1) Then Exit
	Else
		Color 255,128,0
		Rect 0,300,400,300,0
		SetFont font2
		Text 200,450,"1024x768",1,1
		Color 200,0,0
		SetFont font1
		Text 200,150,"640x480",1,1
		Text 600,150,"800x600",1,1
		Text 600,450,"1280x1024",1,1
		GW = 1024
		GH = 768
		If MouseHit(1) Then Exit
	End If
Else
	If MouseY() < 300 Then
		Color 255,128,0
		Rect 400,0,400,300,0
		SetFont font2
		Text 600,150,"800x600",1,1
		Color 200,0,0
		SetFont font1
		Text 200,450,"1024x768",1,1
		Text 200,150,"640x480",1,1
		Text 600,450,"1280x1024",1,1
		GW = 800
		GH = 600		
		If MouseHit(1) Then Exit

	Else
		Color 255,128,0
		Rect 400,300,400,300,0
		SetFont font2
		Text 600,450,"1280x1024",1,1
		Color 200,0,0
		SetFont font1
		Text 200,150,"640x480",1,1
		Text 600,150,"800x600",1,1
		Text 200,450,"1024x768",1,1
		GW = 1280
		GH = 1024
		If MouseHit(1) Then Exit

	End If
End If
Flip
Forever

Graphics3D GW,GH,32,1
SetBuffer BackBuffer()

fnt = LoadFont ("arial",20)
SetFont fnt

Global vector# = 1
Global jump =1

Const GRND = 1, PLR = 2

cam = CreateCamera()
light = CreateLight()

ground = LoadTerrain("kartavisot.bmp")
grndtex = LoadTexture("ground.dds")
ScaleEntity ground, 1,10,1
ScaleTexture grndtex,10,10
PositionEntity ground,-100,0,-100
TerrainShading ground,1
EntityType ground,grnd
EntityTexture ground,grndtex
FreeTexture grndtex

player = CreateCube()
ScaleEntity player,5,5,5
EntityRadius player,5
aura = CreateLight(2)
LightRange aura,10
LightColor aura,20,50,100
EntityParent aura,player
PositionEntity player,0,10,0
EntityType player,plr

Collisions plr,grnd,2,2

Repeat
cycletime = MilliSecs()
	arrowkeys player
	mouselook(cam)
	control(cam)
	
	If jump = 1 Then
		TranslateEntity player,0,vector*dt*.1,0
		vector = vector - .001*dt
	End If
	
	If KeyHit(57) And jump=0 Then vector = 1: jump = 1
	
	UpdateWorld
	If jump = 1 Then
		If EntityCollided (player,grnd) Then 	jump = 0
	End If
	RenderWorld
	Text 20,20,"? "+jump
	Flip
dt = MilliSecs()-cycletime
Until KeyHit(1)
End